VERSION 5.00
Object = "{CAB249C7-BAC9-4C51-9526-12F29E40C4CE}#2.2#0"; "ExTvw.ocx"
Begin VB.Form frmTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   4920
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5580
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   OLEDropMode     =   1  'Manuell
   ScaleHeight     =   328
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   372
   StartUpPosition =   2  'Bildschirmmitte
   Begin ExTvw.ExplorerTreeView ExTvw1 
      Height          =   4695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5295
      _ExtentX        =   9340
      _ExtentY        =   8281
      DimSelectedItemsIcon=   -1  'True
      DragExpandTime  =   1000
      DragScrollTime  =   200
      FileAttributes  =   63
      FolderAttributes=   63
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      IncludedItems   =   15
      Indent          =   19
      ItemHeight      =   17
      ShowFocusRect   =   0   'False
      SingleExpand    =   1
      TreeViewStyle   =   1
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Implements ISubClass


  Private Type RECT
    lLeft As Long
    lTop As Long
    lRight As Long
    lBottom As Long
  End Type

  Private Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
  End Type

  Private Type NMCUSTOMDRAW
    hdr As NMHDR
    dwDrawStage As Long
    hDC As Long
    rc As RECT
    dwItemSpec As Long
    uItemState As Long
    lItemlParam As Long
  End Type

  Private Type NMTVCUSTOMDRAW
    nmcd As NMCUSTOMDRAW
    clrText As Long
    clrTextBk As Long
    iLevel As Long
  End Type

  Private Type GRADIENT_RECT
    UpperLeft As Long
    LowerRight As Long
  End Type

  Private Type TRIVERTEX
    x As Long
    y As Long
    Red As Integer
    Green As Integer
    Blue As Integer
    Alpha As Integer
  End Type


  Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal Size As Long)
  Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
  Private Declare Function GetAncestor Lib "user32.dll" (ByVal hWnd As Long, ByVal Flags As Long) As Long
  Private Declare Function GradientFill Lib "msimg32.dll" (ByVal hDC As Long, ByRef pVertex As TRIVERTEX, ByVal dwNumVertex As Long, ByVal pMesh As Long, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long
  Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
  Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hDC As Long, ByVal nBkMode As Long) As Long
  Private Declare Function SetTextColor Lib "gdi32.dll" (ByVal hDC As Long, ByVal crColor As Long) As Long


Private Function ISubClass_GetAppIdentifier() As String
  ISubClass_GetAppIdentifier = "ExTvwSample"
End Function

Private Function ISubClass_GetProcessingOrder(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As ProcessingOrderConstants
  Const WM_NOTIFY = &H4E

  Select Case Msg
    Case WM_NOTIFY
      ' let ExplorerTreeView handle this message first
      ISubClass_GetProcessingOrder = ProcessingOrderConstants.poProcessAfterOriginal
    Case Else
      ISubClass_GetProcessingOrder = ProcessingOrderConstants.poProcessOriginalOnly
  End Select
End Function

Private Function ISubClass_WinMain(ByVal iListener As Long, ByVal oldWinMain As Long, ByVal oldRetVal As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Const CDDS_ITEM = &H10000
  Const CDDS_POSTPAINT = &H2
  Const CDDS_PREPAINT = &H1
  Const CDDS_ITEMPOSTPAINT = (CDDS_ITEM Or CDDS_POSTPAINT)
  Const CDDS_ITEMPREPAINT = (CDDS_ITEM Or CDDS_PREPAINT)
  Const CDIS_SELECTED = &H1
  Const CDRF_DODEFAULT = &H0
  Const CDRF_NOTIFYITEMDRAW = &H20
  Const CDRF_NOTIFYPOSTPAINT = &H10
  Const DT_LEFT = &H0
  Const DT_SINGLELINE = &H20
  Const DT_VCENTER = &H4
  Const GRADIENT_FILL_RECT_H = &H0
  Const NM_FIRST = 0
  Const NM_CUSTOMDRAW = (NM_FIRST - 12)
  Const TRANSPARENT = 1
  Const WM_NOTIFY = &H4E
  Dim CDrawData As NMTVCUSTOMDRAW
  Dim gRect As GRADIENT_RECT
  Dim NotDetails As NMHDR
  Dim rc As RECT
  Dim rcItem As ITEMRECT
  Dim vertex(0 To 1) As TRIVERTEX

  Select Case Msg
    Case WM_NOTIFY
      CopyMemory NotDetails, ByVal lParam, LenB(NotDetails)
      Select Case NotDetails.code
        Case NM_CUSTOMDRAW
          CopyMemory CDrawData, ByVal lParam, LenB(CDrawData)
          With CDrawData.nmcd
            Select Case .dwDrawStage
              Case CDDS_PREPAINT
                ISubClass_WinMain = CDRF_NOTIFYITEMDRAW

              Case CDDS_ITEMPREPAINT
                If .uItemState And CDIS_SELECTED Then
                  ISubClass_WinMain = CDRF_NOTIFYPOSTPAINT
                Else
                  ISubClass_WinMain = CDRF_DODEFAULT
                End If

              Case CDDS_ITEMPOSTPAINT
                ' NMCUSTOMDRAW.rc contains the entire row's rectangle, so we can't use it
                ExTvw1.ItemGetRectangle .dwItemSpec, rcItem
                vertex(0).x = rcItem.rcLeft
                vertex(0).y = rcItem.rcTop
                vertex(1).x = rcItem.rcRight
                vertex(1).y = rcItem.rcBottom

                vertex(0).Blue = CCol(&HFF)
                vertex(1).Red = CCol(&HFF)
                gRect.UpperLeft = 0
                gRect.LowerRight = 1
                GradientFill .hDC, vertex(0), 2, VarPtr(gRect), 1, GRADIENT_FILL_RECT_H

                ' now draw the text
                LSet rc = rcItem
                rc.lLeft = rc.lLeft + 2
                SetBkMode .hDC, TRANSPARENT
                SetTextColor .hDC, vbWhite
                DrawText .hDC, ExTvw1.ItemHandleToDisplayName(.dwItemSpec), -1, rc, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER

                ISubClass_WinMain = CDRF_DODEFAULT
            End Select
          End With
      End Select
  End Select
End Function

' http://www.activevb.de/tipps/vb6tipps/tipp0166.html
Private Function CCol(ByVal Col As Byte) As Integer
  If Col > &H7F Then
    CCol = (Col * &H100&) - &H10000
  Else
    CCol = Col * &H100&
  End If
End Function

Private Sub Form_Initialize()
  InitCommonControls
End Sub

Private Sub Form_Load()
  Const GA_PARENT = 1

  StartListening Me, GetAncestor(ExTvw1.hWnd, GA_PARENT)
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Const GA_PARENT = 1

  StopListening Me, GetAncestor(ExTvw1.hWnd, GA_PARENT)
End Sub
